package com.mgh.pmdm.parques.view.dialogs

import android.app.Dialog
import android.os.Bundle
import androidx.appcompat.app.AlertDialog
import androidx.fragment.app.DialogFragment
import androidx.fragment.app.Fragment
import com.mgh.pmdm.parques.viewmodel.MainViewModel

class MiDialogFragment(
    var title: String ="Título por defecto",
    var content: String ="Contenido por defecto",
    var frag: Fragment
) : DialogFragment() {
        interface OnOKOrCancelListener {
            fun onPositiveClick()
            fun onCancelClick()
        }

    // Definimos una instancia del ViewModel como lateinit
    //private lateinit var miDialogViewModel: MiDialogFragmentViewModel
    private lateinit var miDialogViewModel: MainViewModel

    override fun onCreateDialog(savedInstanceState: Bundle?): Dialog {
        // OJO: Método Obsoleto, y que puede causar fugas de memoria
        //      La solución pasa por aplicar un ViewModel también para el diálogo
        //      podéis encontrarla en la web de recursos externa.
        setRetainInstance(true)


        return activity?.let {
            val builder: AlertDialog.Builder = AlertDialog.Builder(requireActivity())
            builder.setTitle(title).setMessage(content)
                .setPositiveButton(android.R.string.ok) { _, _ ->
                    //val listener = activity as OnOKOrCancelListener?
                    val listener = frag as OnOKOrCancelListener?
                    listener!!.onPositiveClick()
                }
                .setNegativeButton(android.R.string.cancel) { _, _ ->
                    //val listener = activity as OnOKOrCancelListener?
                    val listener = frag as OnOKOrCancelListener?
                    listener!!.onCancelClick()
                }
            return builder.create() // Devuelve un AlertDialog, tal y como lo hemos definido al Builder
        } ?: throw IllegalStateException("El fragmento no está asociado a ninguna actividad")
    }
}
